#pragma once

#include "FTState.h"

namespace FileTransferState{
	class CFTStateManager
	{
	public:
		CFTStateManager(UIChatFileElement * pUIElem);
		~CFTStateManager();
		void SetState(_enum_file_transfer_state state);
		_enum_file_transfer_state GetState() { return m_state; }

		CSize CalcSize(const CPoint& ptPos, DWORD dwFlags, CRect& rc);
		BOOL DrawItems(Graphics *pGraph); 

		void OnLButtonDown(UINT nFlags, CPoint point);
		void OnLButtonUp(UINT nFlags, CPoint point);
		BOOL OnMouseMove( UINT nFlags, CPoint point );
	private:
		void _UpdateState();
	private:
		CCriticalSection	m_csLock;

		UIChatFileElement * m_pUIElem;
		_enum_file_transfer_state m_state;
		CFTState*   m_pState;
	};
}
